
from CvPythonExtensions import *
import PyHelpers
gc = CyGlobalContext()
PyInfo = PyHelpers.PyInfo

class Dynamica:

    def __init__(self):

        ##This list will hold designated techs for each flavor
        self.lDesignatedTechs = []

        ## Variables governing flavor grants
        self.minFlavorValue = 5 ## change this to affect how much of a flavor a tech needs for it to count
        self.iBase = 30
        self.iCommerceDivisor = 1 ## Divide all the commerce bonuses by this number
        self.iRandomness = 20
        ## Later can add bonuses for traits and whatever
        
        ## Divisors for turn bonuses
        self.fMilitaryUnitsDivisor = 2
        self.fReligionCitiesDivisor = 0.25
        self.fProductionDivisor = 2
        self.fGoldDivisor = 2
        self.fResearchDivisor = 4
        self.fCultureDivisor = 10
        self.fFoodDivisor = 3
        self.fEspionageDivisor = 10

    def checkFinished(self, iPlayer, iTech):
        pPlayer = gc.getPlayer(iPlayer)
        if gc.getTeam(pPlayer.getTeam()).isHasTech(iTech):
            try:
                j = self.lDesignatedTechs[iPlayer]
            except IndexError:
                CyInterface().addImmediateMessage("Index error, used index %d, length is %d" % (iPlayer, len(self.lDesignatedTechs)),"")
            else: 
                if iTech in self.lDesignatedTechs[iPlayer]:
                    iFlavor = self.lDesignatedTechs[iPlayer].index(iTech)
                    self.setDesignatedTech(iFlavor, iPlayer)
   
    def checkTechs(self, iPlayer):
        pPlayer = gc.getPlayer(iPlayer)
        try:
            j = self.lDesignatedTechs[iPlayer]
        except IndexError:
            doNothing = True ## Lol
        else:
            for iFlavor in range(len(self.lDesignatedTechs[iPlayer])):
                if self.lDesignatedTechs[iPlayer][iFlavor] == -1:
                    self.setDesignatedTech(iFlavor, iPlayer)
                elif gc.getTeam(pPlayer.getTeam()).isHasTech(self.lDesignatedTechs[iPlayer][iFlavor]):
                    self.setDesignatedTech(iFlavor, iPlayer)
    

    ##Generic function to give a piece of a tech
    def giveTech(self, iPlayer, iTech, iAmount):
        pPlayer = gc.getPlayer(iPlayer)
        iTeam = pPlayer.getTeam()
        pTeam = gc.getTeam(iTeam)
        pTeam.changeResearchProgress(iTech, iAmount, iPlayer)
        if abs(iAmount) > 1000:
            CyInterface().addImmediateMessage("Whoa! giveTech Giving %d beakers for flavor %d" % (iAmount, iFlavor),"")
        self.checkFinished(iPlayer, iTech)

    ## This function figures out if the player can "research" the tech or not
    ## i.e. if they have the prerequisite techs
    ## Can't use "canResearch" because techs are disabled
    ## old method. use the new method "isHasPrerequisites"
    def isPossibleTech(self, iTech, iPlayer):
        pPlayer = gc.getPlayer(iPlayer)
        pTeam = gc.getTeam(pPlayer.getTeam())
        techInfo = gc.getTechInfo(iTech)
        if pTeam.isHasTech(iTech):
            return False
        isPossible = False
        if techInfo.getPrereqAndTechs(0) == -1:
            if techInfo.getPrereqOrTechs(0) == -1:
                isPossible = True
            else:
                for i in range(gc.getDefineINT("NUM_OR_PREREQ_TECHS")):
                    if pTeam.isHasTech(techInfo.getPrereqOrTechs(i)):
                        isPossible = True
        else:
            isPossible = True
            for i in range(gc.getDefineINT("NUM_AND_PREREQ_TECHS")):
                if not pTeam.isHasTech(techInfo.getPrereqAndTechs(i)):
                    isPossible = False
            if isPossible:
                isPossible = False
                for i in range(gc.getDefineINT("NUM_OR_PREREQ_TECHS")):
                    if pTeam.isHasTech(techInfo.getPrereqOrTechs(i)):
                        isPossible = True
        return isPossible
                
            

    ## This function returns a player's designated tech
    def getPlayerTech(self, iPlayer, iFlavor):
        try:
            iTech = self.lDesignatedTechs[iPlayer][iFlavor]
        except IndexError:
            CyInterface().addImmediateMessage("tried to get %d player %d flavor, but that doesn't exist" % (iPlayer, iFlavor),"")
        except TypeError:
            CyInterface().addImmediateMessage("iTech is being seen as %s" % iTech,"")
        else:
            return iTech
        

    ## This function gives specified beakers toward the player's designated tech
    def giveFlavorTech(self, iPlayer, iFlavor, iAmount):
        pPlayer = gc.getPlayer(iPlayer)
        iTeam = pPlayer.getTeam()
        pTeam = gc.getTeam(iTeam)
        pTeam.changeResearchProgress(iTech, iAmount, iPlayer)
        if abs(iAmount) > 1000:
            CyInterface().addImmediateMessage("Whoa! giveFlavorTech Giving %d beakers for flavor %d" % (iAmount, iFlavor),"")
        self.checkFinished(iPlayer, iTech)
        techInfo = gc.getTechInfo(iTech)
        ##CyInterface().addMessage(iPlayer, False, 10, "You have received %x beakers toward %s" % (iAmount, techInfo.getDescription))
        
    ## This function gives beakers based on some value like commerce
    def giveFlavorTech_Num(self, iPlayer, iFlavor, iThing):
        pPlayer = gc.getPlayer(iPlayer)
        iTeam = pPlayer.getTeam()
        pTeam = gc.getTeam(iTeam)
        iTech = self.getPlayerTech(iPlayer, iFlavor)
        #if pPlayer.isHuman():
            #if iFlavor == 2:
                #CyInterface().addImmediateMessage("player's tech for flavor %d is tech %d"%(iFlavor, iTech),"")
        iAmount = iThing / self.iCommerceDivisor
        try:
            iTechy = iTech + 5
        except TypeError:
            CyInterface().addImmediateMessage("For some reason the game is not retrieving a tech properly.","")
        else:
            if iTech > 0:
                pTeam.changeResearchProgress(iTech, iAmount, iPlayer)
                if abs(iAmount) > 1000:
                    CyInterface().addImmediateMessage("Whoa! giveFlavorTech_Num Giving %d beakers for flavor %d" % (iAmount, iFlavor),"")
                self.checkFinished(iPlayer, iTech)
                techInfo = gc.getTechInfo(iTech)
                ##CyInterface().addMessage(iPlayer, False, 10, "You have received %x beakers toward %s" % (iAmount, techInfo.getDescription()))

    def getHighestFlavor(self, thingInfo):
        highVal = 0
        highIndex = -1
        for iFlavor in xrange(gc.getNumFlavorTypes()):
            if thingInfo.getFlavorValue(iFlavor) > highVal:
                highVal = thingInfo.getFlavorValue(iFlavor)
                highIndex = iFlavor
        return highIndex

    ##This function gives random amount of beakers toward designated tech
    def giveFlavorTech_Rand(self, iPlayer, iFlavor, iDivisor = 1, iRandomness = -1):
        if iRandomness == -1:
            iRandomness = self.iRandomness
        pPlayer = gc.getPlayer(iPlayer)
        iTeam = pPlayer.getTeam()
        pTeam = gc.getTeam(iTeam)
        iRand = CyGame().getSorenRandNum(2*iRandomness, "randomness value")
        iRand -= iRandomness
        iTech = self.getPlayerTech(iPlayer, iFlavor)
        techInfo = gc.getTechInfo(iTech)
        iAmount = (self.iBase + iRand)/iDivisor
        if iTech > -1:
            pTeam.changeResearchProgress(iTech, iAmount, iPlayer)
            if abs(iAmount) > 1000:
                CyInterface().addImmediateMessage("Whoa! giveFlavorTech_Rand Giving %d beakers for flavor %d" % (iAmount, iFlavor),"")
            self.checkFinished(iPlayer, iTech)
        ##CyInterface().addMessage(pPlayer, False, 10, "You have received %x beakers toward %s" % (iAmount, techInfo.getDescription))


    def findSuitableTech(self, iPlayer, iFlavor):
        pPlayer = gc.getPlayer(iPlayer)
        iTeam = pPlayer.getTeam()
        pTeam = gc.getTeam(iTeam)
        lTechs = []
        for iTech in xrange(gc.getNumTechInfos()):
            techInfo = gc.getTechInfo(iTech)
            iTechFlavor = techInfo.getFlavorValue(iFlavor)
            if iTechFlavor >= self.minFlavorValue:
                if self.isHasPrerequisites(iTech, iPlayer):
                    lTechs.append(iTech)
        if len(lTechs) < 1:
            ##Debugging stuff
            #if iFlavor != 7:
                #CyInterface().addImmediateMessage("There are no suitable techs for player %d flavor %d." % (iPlayer, iFlavor),"")
            return -1
        else:
            ## This loop favors techs that already have some progress, which
            ## might allow you to save progress between games.
            iReturnTech = -1
            iProgress = 0
            for jTech in range(len(lTechs)):
                if pTeam.getResearchProgress(jTech) > iProgress:
                    iProgress = pTeam.getResearchProgress(jTech)
                    iReturnTech = jTech
            if iReturnTech < 0:
                iTechIndex = CyGame().getSorenRandNum(len(lTechs), "Which tech to choose")
            else:
                iTechIndex = iReturnTech
            return lTechs[iTechIndex]
        
    ## Returns whether or not a tech can be researched, but does not count "disabled" as unable to research
    def isHasPrerequisites(self, iTech, iPlayer):
        bFoundPossible = False
        bFoundValid = False
        pPlayer = gc.getPlayer(iPlayer)
        iTeam = pPlayer.getTeam()
        pTeam = gc.getTeam(iTeam)
        
        if pTeam.isHasTech(iTech):
            return False
        for i in range(gc.getNUM_OR_TECH_PREREQS()):
            iPrereq = gc.getTechInfo(iTech).getPrereqOrTechs(i)
            if (iPrereq > -1):
                bFoundPossible = True
                if pTeam.isHasTech(iPrereq):
                    bFoundValid = True
                    break
        if (bFoundPossible and not bFoundValid):
            return False
        
        for i in range(gc.getNUM_AND_TECH_PREREQS()):
            iPrereq = gc.getTechInfo(iTech).getPrereqAndTechs(i)
            if (iTech > -1):
                if not (pTeam.isHasTech(iPrereq)):
                    return False
        return True       
        
            

    ## This function sets a designated tech for a specific player
    def setDesignatedTech(self, iFlavor, iPlayer, iTech = -1):
        if iTech == -1:
            iTech = self.findSuitableTech(iPlayer, iFlavor)
        self.lDesignatedTechs[iPlayer][iFlavor] = iTech

    ## This function sets (or resets) all of the designated techs
    def setAllDesignatedTechs(self):
        self.lDesignatedTechs = []
        for iPlayer in range(gc.getMAX_PLAYERS()):
            lPlayerTechs = []
            for iFlavor in range(gc.getNumFlavorTypes()):
                iTech = self.findSuitableTech(iPlayer, iFlavor)
                lPlayerTechs.append(iTech)
            self.lDesignatedTechs.append(lPlayerTechs)
    
    ## This handles the bonuses per turn
    def giveTrickleBonuses(self, iPlayer):
        dPlayer = gc.getPlayer(iPlayer)
        ## Military
        milAmount = int(float(dPlayer.getNumMilitaryUnits()) / self.fMilitaryUnitsDivisor)
        self.giveFlavorTech_Num(iPlayer, gc.getTypesEnum("FLAVOR_MILITARY"), milAmount)
        ## Religion
        relAmount = 0
        if dPlayer.isStateReligion():
            iStateReligion = dPlayer.getStateReligion()
            if iStateReligion > -1:
                relAmount = int(float(dPlayer.getHasReligionCount(iStateReligion)) / self.fReligionCitiesDivisor)
                self.giveFlavorTech_Num(iPlayer, gc.getTypesEnum("FLAVOR_RELIGION"), relAmount)
        ## Production
        prodAmount = int(float(dPlayer.calculateTotalYield(1)) / self.fProductionDivisor)
        self.giveFlavorTech_Num(iPlayer, gc.getTypesEnum("FLAVOR_PRODUCTION"), prodAmount)
        ## Gold
        goldAmount = int(float(dPlayer.calculateTotalYield(2)) / self.fGoldDivisor)
        self.giveFlavorTech_Num(iPlayer, gc.getTypesEnum("FLAVOR_COMMERCE"), prodAmount)
        ## Science
        sciAmount = int(float(dPlayer.calculateBaseNetResearch()) / self.fResearchDivisor)
        self.giveFlavorTech_Num(iPlayer, gc.getTypesEnum("FLAVOR_SCIENCE"), sciAmount)
        ## Culture
        culAmount = int(float(dPlayer.countTotalCulture()) / self.fCultureDivisor)
        self.giveFlavorTech_Num(iPlayer, gc.getTypesEnum("FLAVOR_CULTURE"), culAmount)
        ##Growth
        groAmount = int(float(dPlayer.calculateTotalYield(0)) / self.fFoodDivisor)
        self.giveFlavorTech_Num(iPlayer, gc.getTypesEnum("FLAVOR_GROWTH"), groAmount)
        ##Espionage
        espAmount = int(float(gc.getTeam(dPlayer.getTeam()).getEspionagePointsEver()) / self.fEspionageDivisor)
        self.giveFlavorTech_Num(iPlayer, gc.getTypesEnum("FLAVOR_ESPIONAGE"), espAmount)
        #if dPlayer.isHuman():
            #CyInterface().addImmediateMessage("Science beakers %d Culture beakers %d Religion beakers %d" % (sciAmount, culAmount, relAmount), "")
        